#!/usr/bin/env lua
-- TODO: figure out why it doesn't find the interpreter


-- connection related variables
local socket  = require("socket")
      host    = host or "localhost"
      port    = port or 2868 
      timeout = timeout or 5


-- should get a nicer way of handling argument someday
-- help message and all that
if arg then
	host    = arg[1] or host
	port    = arg[2] or port
   timeout = arg[3] or timeout
end


--------------- -----
-- Functions -- -- apparently those need to be defined in the right sequence :/
--------------- -----


local function connect( host, port, timeout )
   ecasocket = socket.tcp()

   -- well, I assume I'll pull for some status every second or so,
   -- so it should only be triggered when something goes wrong
   ecasocket:settimeout( timeout )

   print( "Attempting connection to host " .. host .. " and port " .. port .. "..." )
   
   -- assert is some funky stuff that prints error messages
   ecasocket = assert( socket.connect( host, port ), "ERROR: Connection failed!" )
   print( "Connected!\n" )
end


-- line input
local function getline()
   print("type eiam commands, empty line to end")
   local l = io.read()
   return l
end


-- this function uses a clever algo to efficiently concatenate strings
-- stolen from: www.lua.org/pil/11.6.html
-- I don't expect the ecasound response to become huge, but who knows

-- stack is a table with an empty string, just a table might work too
local function addString (stack, str)
   table.insert(stack, str)    -- push 'str' into the the stack
      for i=table.getn(stack)-1, 1, -1 do
         if string.len(stack[i]) > string.len(stack[i+1]) then
            break
         end
      stack[i] = stack[i] .. table.remove(stack)
   end
end


-- generic send function
local function send( eiam )
   assert( ecasocket:send( eiam .. "\r\n" ), "ERROR: Send failed!" )
end

-- generic receive function
local function receive()
   local str = {""} 

   repeat
      line, e = ecasocket:receive()
      --[[ seems to work without, but who knows...
      line = tostring(line)
      --]]
      addString(str, line .. "\n")
   until line == ""

   str = table.concat(str)

   return str
end

-- generic send and read response aka. query
local function query( eiam )
   send( eiam )
   return receive() 
end


---------------------------------
-- End of Function Definitions --
---------------------------------


-- simple array with a sequence of commands - /me now needs to find the correct commands :)
statustable = {"engine-status", "cs-list", "cs-status", "c-list", "c-status", "ai-list" ,"ao-list", "aio-status" }

--[[ Plan:
-- work with 'untitled-chainsetup' for now
-- add commands step-by-step to recordtable
-- eventually, append an output to file to the table; use this for the takes
--]]

--TODO: set format somehow
--recordtable = {"ai-add jack","ao-add testrec.wav"}

connect( host, port, timeout )

repeat

   for i, j in pairs(statustable) do print( query(j) ) end

   print("===>\n" .. query(getline()))

   -- yay, eventually found a way to sleep! I almost thought it's impossible in lua.
   -- actually it is, it uses some funky stuff and nanosleep from time.h
   -- lua is implemented using the common subset of ANSI C and C++,
   -- which doesn't include sleep or timers
   -- socket.sleep(2)

-- tail control is nice in this case
until e

print ( e )
ecasocket:close()
os.exit( e )
